
C Program simply reads through a standard escalc ctr file and repeats the
C output with relevant (current) mods according to environment variables.

	CHARACTER*78	line
	CHARACTER*60	eg_path, molecule_coords, ph, cys_include,
     1			all_charges
	CHARACTER*4	flag

1100	FORMAT (A78)
1200	FORMAT (A4)

	CALL	GETENV ('EXAMPLES', eg_path)
	CALL	leader (eg_path, iep)

	CALL	GETENV ('MOLECULE_COORDS', molecule_coords)
	CALL	leader (molecule_coords, imc)

	CALL	GETENV ('CYS_INCLUDE', cys_include)
	CALL	leader (cys_include, ici)

C We ONLY add an 'all' set if all_charges -> 'YES'
	CALL	GETENV ('ALL_CHARGES', all_charges)
	CALL	leader (all_charges, iac)

C -------- First the full charge input files --------
C -------- the 'full' .ctr file

Clnx	OPEN (UNIT=1,NAME=eg_path (1:iep)//'/escalc_std.ctr',
Clnx     1	      READONLY)
Clnx 	OPEN (UNIT=2,
Clnx     1	        NAME='es_'//molecule_coords (1:imc)//'_full.ctr',
Clnx     2		TYPE='NEW', CARRIAGECONTROL='LIST')
	OPEN (UNIT=1,NAME=eg_path (1:iep)//'/escalc_std.ctr')
 	OPEN (UNIT=2,
     1	        NAME='es_'//molecule_coords (1:imc)//'_full.ctr',
     2		TYPE='NEW')

200	READ (1,1100,END=250) line
	READ (line,1200) flag

	IF      (flag .EQ. 'NFIL') THEN
	  WRITE (2,1100) line
	  READ (1,1100) line
	  IF (line (1:1) .NE. '1') STOP '> 1 i/p file sets'
	  WRITE (2,1100) line

	ELSE IF (flag .EQ. 'DATA') THEN
	  WRITE (2,1100) line
	  READ (1,*)
	  READ (1,*)
	  WRITE (2,*) molecule_coords (1:imc)//'_es.pdb'
	  WRITE (2,*) 'es_'//molecule_coords (1:imc)//'_full.chr'

	ELSE IF (flag .EQ. 'FILE') THEN
	  WRITE (2,1100) line
	  READ (1,*)
	  READ (1,*)
	  WRITE (2,*) 'es_'//molecule_coords (1:imc)//'_full.inf'
	  WRITE (2,*) 'es_'//molecule_coords (1:imc)//'_full.qop'

	ELSE IF (flag .EQ. 'PH  ') THEN
	  WRITE (2,1100) line
	  READ (1,*)
	  CALL	GETENV ('PH', ph)
	  CALL	leader (ph, iph)
	  WRITE (2,*) ph (1:iph)

	ELSE
	  WRITE (2,1100) line
	END IF
	GOTO 200

250	CLOSE (UNIT=1)
	CLOSE (UNIT=2)

C -------- the 'full' .chr file

Clnx	OPEN (UNIT=1,NAME=eg_path (1:iep)//'/escalc_full_std.chr',
Clnx     1	      READONLY)
Clnx 	OPEN (UNIT=2,
Clnx     1	        NAME='es_'//molecule_coords (1:imc)//'_full.chr',
Clnx     2		TYPE='NEW', CARRIAGECONTROL='LIST')
	OPEN (UNIT=1,NAME=eg_path (1:iep)//'/escalc_full_std.chr')
 	OPEN (UNIT=2,
     1	        NAME='es_'//molecule_coords (1:imc)//'_full.chr',
     2		TYPE='NEW')

300	READ (1,1100,END=350) line
	READ (line,1200) flag
	IF (flag .EQ. 'EXCL') THEN
	  WRITE (2,1100) line
	  IF (cys_include (1:ici) .EQ. 'yes') THEN
	    READ (1,*)
	    READ (1,*)
	    WRITE (2,*) '0'
	  ELSE
	    READ (1,1100) line
	    WRITE (2,1100) line
	    READ (1,1100) line
	    WRITE (2,1100) line
	  END IF
	ELSE
	  WRITE (2,1100) line
	END IF
	GOTO 300

350	CLOSE (UNIT=1)
	CLOSE (UNIT=2)

C -------- Second the fixed charge input files --------
C -------- the 'fixed' .ctr file

Clnx	OPEN (UNIT=1,NAME=eg_path (1:iep)//'/escalc_std.ctr',
Clnx     1	      READONLY)
Clnx 	OPEN (UNIT=2,
Clnx     1	        NAME='es_'//molecule_coords (1:imc)//'_fixed.ctr',
Clnx     2		TYPE='NEW', CARRIAGECONTROL='LIST')
	OPEN (UNIT=1,NAME=eg_path (1:iep)//'/escalc_std.ctr')
 	OPEN (UNIT=2,
     1	        NAME='es_'//molecule_coords (1:imc)//'_fixed.ctr',
     2		TYPE='NEW')

400	READ (1,1100,END=450) line
	READ (line,1200) flag

	IF      (flag .EQ. 'NFIL') THEN
	  WRITE (2,1100) line
	  READ (1,1100) line
	  IF (line (1:1) .NE. '1') STOP '> 1 i/p file sets'
	  WRITE (2,1100) line

	ELSE IF (flag .EQ. 'DATA') THEN
	  WRITE (2,1100) line
	  READ (1,*)
	  READ (1,*)
	  WRITE (2,*) molecule_coords (1:imc)//'_esH.pdb'
	  WRITE (2,*) 'es_'//molecule_coords (1:imc)//'_fixed.chr'

	ELSE IF (flag .EQ. 'FILE') THEN
	  WRITE (2,1100) line
	  READ (1,*)
	  READ (1,*)
	  WRITE (2,*) 'es_'//molecule_coords (1:imc)//'_fixed.inf'
	  WRITE (2,*) 'es_'//molecule_coords (1:imc)//'_fixed.qop'

	ELSE IF (flag .EQ. 'PH  ') THEN
	  WRITE (2,1100) line
	  READ (1,*)
	  CALL	GETENV ('PH', ph)
	  CALL	leader (ph, iph)
	  WRITE (2,*) ph (1:iph)

	ELSE
	  WRITE (2,1100) line
	END IF
	GOTO 400

450	CLOSE (UNIT=1)
	CLOSE (UNIT=2)

C -------- the 'fixed' .chr file

Clnx	OPEN (UNIT=1,NAME=eg_path (1:iep)//'/escalc_fixed_std.chr',
Clnx     1	      READONLY)
Clnx 	OPEN (UNIT=2,
Clnx     1	        NAME='es_'//molecule_coords (1:imc)//'_fixed.chr',
Clnx     2		TYPE='NEW', CARRIAGECONTROL='LIST')
	OPEN (UNIT=1,NAME=eg_path (1:iep)//'/escalc_fixed_std.chr')
 	OPEN (UNIT=2,
     1	        NAME='es_'//molecule_coords (1:imc)//'_fixed.chr',
     2		TYPE='NEW')

500	READ (1,1100,END=550) line
	READ (line,1200) flag
	WRITE (2,1100) line
	GOTO 500

550	CLOSE (UNIT=1)
	CLOSE (UNIT=2)

C -------- Third the whole charge set ('all') input files (if flagged)
C -------- the 'all' .ctr file

	IF (all_charges (1:3) .EQ. 'YES') THEN
	  OPEN (UNIT=1,NAME=eg_path (1:iep)//'/escalc_std.ctr')
 	  OPEN (UNIT=2,
     1	        NAME='es_'//molecule_coords (1:imc)//'_all.ctr',
     2		TYPE='NEW')

600	  READ (1,1100,END=650) line
	  READ (line,1200) flag
	  IF      (flag .EQ. 'NFIL') THEN
	    WRITE (2,1100) line
	    READ (1,1100) line
	    IF (line (1:1) .NE. '1') STOP '> 1 i/p file sets'
	    WRITE (2,1100) line
	  ELSE IF (flag .EQ. 'DATA') THEN
	    WRITE (2,1100) line
	    READ (1,*)
	    READ (1,*)
	    WRITE (2,*) molecule_coords (1:imc)//'_esH.pdb'
	    WRITE (2,*) 'es_'//molecule_coords (1:imc)//'_all.chr'
	  ELSE IF (flag .EQ. 'FILE') THEN
	    WRITE (2,1100) line
	    READ (1,*)
	    READ (1,*)
	    WRITE (2,*) 'es_'//molecule_coords (1:imc)//'_all.inf'
	    WRITE (2,*) 'es_'//molecule_coords (1:imc)//'_all.qop'
	  ELSE IF (flag .EQ. 'PH  ') THEN
	    WRITE (2,1100) line
	    READ (1,*)
	    CALL	GETENV ('PH', ph)
	    CALL	leader (ph, iph)
	    WRITE (2,*) ph (1:iph)
	  ELSE
	    WRITE (2,1100) line
	  END IF
	  GOTO 600

650	  CLOSE (UNIT=1)
	  CLOSE (UNIT=2)

C -------- the 'all' .chr file
	  OPEN (UNIT=1,NAME=eg_path (1:iep)//'/escalc_all_std.chr')
 	  OPEN (UNIT=2,
     1	        NAME='es_'//molecule_coords (1:imc)//'_all.chr',
     2		TYPE='NEW')

700	  READ (1,1100,END=750) line
	  READ (line,1200) flag
	  IF (flag .EQ. 'EXCL') THEN
	    WRITE (2,1100) line
	    IF (cys_include (1:ici) .EQ. 'yes') THEN
	      READ (1,*)
	      READ (1,*)
	      WRITE (2,*) '0'
	    ELSE
	      READ (1,1100) line
	      WRITE (2,1100) line
	      READ (1,1100) line
	      WRITE (2,1100) line
	    END IF
	  ELSE
	    WRITE (2,1100) line
	  END IF
	  GOTO 700

750	  CLOSE (UNIT=1)
	  CLOSE (UNIT=2)
	END IF

	CALL	EXIT
	END


	SUBROUTINE	leader (char_array, itop)
C	**********	******

	CHARACTER*60	char_array

	itop	= 1
	DO WHILE (char_array (itop:itop) .NE. ' ')
	  itop	= itop + 1
	END DO
	itop	= itop - 1

	RETURN
	END

