
C Program	P O L H _ G E N

C This version updated (April.94) from polh_gen to handle the new NT stuff.
C We have decided to put nres NT at first nres LESS one, and nres CT,OT's
C at last nres PLUS one - giving ionisable group uniqueness.  But because
C of the way we read residues in, polh_gen cannot handle this NT nres.
C Therefore we'll write a temporary coord file the same as i/p except for
C NT nres = first nres - then we can hadle it in polh_gen.
C We also use a check on HT1,HT2 or HT3 output for nres decrementing, so
C that these atoms types needto be unique in atoms_es.dat.

C Program to generate polar hydrogen atoms for a PDB format coordinate file.
C The atoms_es.dat data file is used to specify where these will go.
C Analagous to GROMOS routines.

C Uses subroutine in ATOMS_DAT module - also used by ESCALC and FDCALC.

C Jim Warwicker, Reading, Oct.1990

C Read in control information from the "polh_gen.ctr" file.

	CALL	read_ctr

C Read in all information in the "atoms_es.dat" file.

	CALL	read_atoms_es

C Mark atom/res combos that remain for hgen once the exclusions have been
C taken into account.

	CALL	mark_hgen_atoms

C And generate the hydrogen atoms as we read, residue by residue.

	CALL	hyd_gen

	CALL	EXIT
	END


C-----------------------------------------------------------------------------C
C									      C
C		SUBROUTINE	read_ctr				      C
C									      C
C-----------------------------------------------------------------------------C

	SUBROUTINE	read_ctr
C	**********	********

C Read control information for this POLH_GEN run.

	LOGICAL		old_coord_nres_I5, write_gen, skip_irel,
     1			skip_absent, remove_base, check_next
	BYTE		spacer (80),
     1			header (80)
	CHARACTER*4	excl_ids (100,2)
	REAL		xyz_here (3)
	CHARACTER*80	line, file_in, file_out
	CHARACTER*4	atyp_here, check, atm
	CHARACTER*1	chain_here

	COMMON	/excl_hgen/	n_excl, excl_ids
	COMMON	/write_out/	write_gen
	COMMON	/skips/		skip_irel, skip_absent, remove_base

	DATA	spacer	/ 80*'-' /
C ??	DATA	file_in, file_out / 60*' ', 60*' ' /

1020	FORMAT (A4)
C??1030	FORMAT (Q,60A1)
1040	FORMAT (A4,2X,A4)
1050	FORMAT (A80)
1100	FORMAT (80A1)
1110	FORMAT (' ',20X,'Info. output file for POLH_GEN run')
1120	FORMAT (' input coordinate file is ',/,A80)
1130	FORMAT ('output coordinate file is ',/,A80)
1220	FORMAT (A4, 9X, A4, A4, A1, I4, 4X, 3F8.3)
1300	FORMAT ('0',' For atyp,res ',A4,2X,A4,' nres has been
     1   updated to ',A1,I4,' on i/p')

9000	FORMAT ('0','*** ERROR * read_ctr * record out of sequence')
9100	FORMAT ('0','*** ERROR * read_ctr * read error')
9200	FORMAT ('0','*** ERROR * read_ctr * n_excl too many')
9300	FORMAT ('0','*** ERROR * read_ctr * non atom record / coords')
9400	FORMAT ('0','*** ERROR * read_ctr * NT / first res-1 - NO')

C Open an information output file "polh_gen.inf".

	OPEN (UNIT=9, NAME='polh_gen.inf', TYPE='NEW')
	WRITE (9,1100) spacer
	WRITE (9,1110)
	WRITE (9,1100) spacer

Clnx	OPEN (UNIT=4, NAME='polh_gen.ctr', TYPE='OLD', READONLY)
	OPEN (UNIT=4, NAME='polh_gen.ctr', TYPE='OLD')
	READ (4,1020) check
	IF (check .NE. 'POLH') GOTO 900
	READ (4,1020) check
	IF (check .NE. 'CRDS') GOTO 900
	READ (4,1050) line
	CALL	get_filename (line, file_in)
	READ (4,1050) line
	CALL	get_filename (line, file_out)
C ??	READ (4,1030,ERR=910) nc, (file_in (ic), ic = 1, nc)
C ??	READ (4,1030,ERR=910) nc, (file_out (ic), ic = 1, nc)
Clnx	OPEN (UNIT=1, NAME=file_in, TYPE='OLD', READONLY)
	OPEN (UNIT=1, NAME=file_in, TYPE='OLD')
	READ (1,1100) header

C Write out the temporary file that we'll process on - with NT nres modified.

	OPEN (UNIT=7, NAME='polh_gen.pep', TYPE='NEW')
	WRITE (7,1100) header
	check_next	= .FALSE.

140	CONTINUE
	READ (1,1220,END=160) atm, atyp_here, res_here, chain_here,
     1			      nres_here, xyz_here
	IF (atm.NE.'ATOM' .AND. atm.NE.'HETA') GOTO 930
	IF (check_next) THEN
	  IF (nres_here .NE. nres_check) GOTO 940
	  check_next	= .FALSE.
	END IF
	IF ((atyp_here.EQ.'NT  ') .OR. (atyp_here.EQ.'NT1 ')) THEN
	  nres_here	= nres_here + 1
	  check_next	= .TRUE.
	  nres_check	= nres_here
	  WRITE (9,1300) atyp_here, res_here, chain_here, nres_here
	END IF
	WRITE (7,1220) atm,atyp_here,res_here,chain_here,nres_here,
     1		       xyz_here
	GOTO 140

160	CLOSE (UNIT=1)
	CLOSE (UNIT=7)
Clnx	OPEN (UNIT=1, NAME='polh_gen.pep', TYPE='OLD',
Clnx     1 	      DISPOSE='DELETE')
	OPEN (UNIT=1, NAME='polh_gen.pep', TYPE='OLD')
	READ (1,1100) header

	OPEN (UNIT=2, NAME=file_out, TYPE='NEW')
	WRITE (2,1100) header
	READ (4,1020) check
	IF (check .NE. 'NRI5') GOTO 900
	READ (4,*) old_coord_nres_I5
	IF (old_coord_nres_I5) STOP 'Oct.2001 - using chainid'
	READ (4,1020) check
	IF (check .NE. 'WRTE') GOTO 900
	READ (4,*) write_gen
	READ (4,1020) check
	IF (check .NE. 'EXCL') GOTO 900
	READ (4,*) n_excl
	IF (n_excl .GT. 100) GOTO 920
	IF (n_excl .NE. 0) THEN
	  DO 200 i_excl	= 1, n_excl
	    READ (4,1040,ERR=910) (excl_ids (i_excl,m), m=1,2)
200	  CONTINUE						! End i_excl
	END IF
	READ (4,1020) check
	IF (check .NE. 'SKIP') GOTO 900
	READ (4,*) skip_irel, skip_absent, remove_base
	READ (4,1020) check
	IF (check .NE. 'END ') GOTO 900

	CLOSE (UNIT=4)

	WRITE (9,1120) file_in
	WRITE (9,1130) file_out

	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT

920	WRITE (6,9200)
	CALL	EXIT

930	WRITE (6,9300)
	CALL	EXIT

940	WRITE (6,9400)
	CALL	EXIT
	END


C-----------------------------------------------------------------------------C
C									      C
C		SUBROUTINE	mark_hgen_atoms				      C
C									      C
C-----------------------------------------------------------------------------C

	SUBROUTINE	mark_hgen_atoms
C	**********	***************

C Override at_hgen = T setting (to F), if this atom/res combo is an exclusion.

	BYTE		spacer (80)
	LOGICAL*1	excl_found

	CHARACTER*4	res_type (200), excl_ids (100,2),
     1			hgen_char (300,3), at_type (2000),
     2			at_prtner (2000), at_hgen_root (2000)
	REAL		at_chrg (2000,4), hgen_real (300,2),
     1			at_pK (2000)
	INTEGER		n_res_ats (200), nat_pter (200,2),
     1			at_class (2000), at_hgen_pter (2000),
     2			hgen_int (300,5)
	CHARACTER*4	res, atyp
	LOGICAL*1	at_hgen (2000), at_anyq (2000),
     1			at_ionise (2000)

	COMMON	/atoms_es_resi/	n_res_types, n_chrg, n_all_at,
     1				res_type, n_res_ats, nat_pter,
     2				at_type, at_class, at_chrg,
     3				at_anyq, at_ionise, at_pK,
     4				at_prtner
	COMMON	/atoms_es_hgen/ at_hgen, at_hgen_pter, at_hgen_root,
     1				hgen_int, hgen_real, hgen_char
	COMMON	/excl_hgen/	n_excl, excl_ids

	DATA	spacer		/ 80*'-' /

1010	FORMAT (80A1)
1020	FORMAT ('0','*** there are NO exclusions from the
     1 "atoms_es.dat" file for H generation')
1030	FORMAT ('0','residue, atom type ',A4,2X,A4,' from the
     1 "atoms_es.dat" file has been excluded')

9000	FORMAT ('0','*** ERROR * mark_hgen_atoms * ia2 .lt. ia1')
9100	FORMAT ('0','*** ERROR * mark_hgen_atoms * at_hgen should
     1 have been found set')
9200	FORMAT ('0','*** ERROR * mark_hgen_atoms * excl not found')

	WRITE (9,1010) spacer
	IF (n_excl .EQ. 0) THEN
	  WRITE (9,1020)
	ELSE
	  DO 500 i_excl		= 1, n_excl
	    res			= excl_ids (i_excl,1)
	    atyp		= excl_ids (i_excl,2)
	    excl_found		= .FALSE.
	    DO 400 ir		= 1, n_res_types
	      IF (res .EQ. res_type (ir)) THEN
		ia1		= nat_pter (ir,1)
		ia2		= nat_pter (ir,2)
		IF (ia2 .LT. ia1) GOTO 900
		DO 300 ia	= ia1, ia2
		  IF (atyp .EQ. at_type (ia)) THEN
		    IF (at_hgen (ia)) THEN
		      at_hgen (ia) = .FALSE.
		      excl_found   = .TRUE.
		      WRITE (9,1030) res, atyp
		      GOTO 500
		    ELSE
		      GOTO 910
		    END IF					! IF at_gen
		  END IF					! IF atyp
300		CONTINUE					! End ia
		IF (.NOT. excl_found) GOTO 920
	      END IF						! IF res
400	    CONTINUE						! End ir
	    IF (.NOT. excl_found) GOTO 920
500	  CONTINUE						! End i_excl
	END IF
	WRITE (9,1010) spacer

	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT

920	WRITE (6,9200)
	CALL	EXIT
	END


C-----------------------------------------------------------------------------C
C									      C
C		SUBROUTINE	hyd_gen					      C
C									      C
C-----------------------------------------------------------------------------C

	SUBROUTINE	hyd_gen
C	**********	*******

C Generate the hydrogen atoms as we read through the input coordinate file,
C residue by residue.

	REAL		xyz_i (3), xyz_j (3), xyz_k (3), xyz_hyd (3,3)
	INTEGER		code
	BYTE		spacer (80)
	LOGICAL*1	common_at
	LOGICAL		end_of_file, write_gen
	CHARACTER*4	buf_atyp (100,2), buf_res (100,2),
     1			buf_atom (100,2)
	REAL		buf_xyz (100,3,2)
	INTEGER		buf_nres (100,2), n_buf (2)
	CHARACTER*1	buf_chain (100,2), chain_this
	CHARACTER*4	atyp, res, atyp_i, atyp_j, atyp_k
	CHARACTER*80	atom_record
	LOGICAL		first_res, first_atom
	CHARACTER*4	res_type (200), common_atyp (100),
     1			hgen_char (300,3), at_type (2000),
     2			at_prtner (2000), at_hgen_root (2000)
	REAL		hgen_real (300,2),
     1			at_chrg (2000,4), at_pK (2000)
	INTEGER		n_res_ats (200), nat_pter (200,2),
     1			at_hgen_pter (2000), hgen_int (300,5),
     2			at_class (2000), common_pter (100)
	LOGICAL*1	at_hgen (2000), at_anyq (2000),
     1			at_ionise (2000)
	LOGICAL		ords_absent, skip_irel, skip_absent,
     1			remove_base

	COMMON	/atoms_es_resi/	n_res_types, n_chrg, n_all_at,
     1				res_type, n_res_ats, nat_pter,
     2				at_type, at_class, at_chrg,
     3				at_anyq, at_ionise, at_pK,
     4				at_prtner
	COMMON	/atoms_es_hgen/ at_hgen, at_hgen_pter, at_hgen_root,
     1				hgen_int, hgen_real, hgen_char
	COMMON	/coord_buf/	buf_atyp, buf_res, buf_xyz,
     1				buf_atom, buf_nres, first_res,
     2				atom_record, n_buf, first_atom,
     3				buf_chain
	COMMON	/common_atoms/	common_atyp, common_pter, n_common
	COMMON	/write_out/	write_gen
	COMMON	/skips/		skip_irel, skip_absent, remove_base

	DATA	spacer	/ 80*'-' /

1010	FORMAT (80A1)
1040	FORMAT (' ','Generating ',I1,' hydrogen atoms attached to
     1 atom ',A4,' of residue ',A4,1X,A1,I4)
1050	FORMAT (' ','hydrogen atom ',A4,3(2X,F8.3))
1100	FORMAT (' ','hydrogens of atom ',A4,' res ',
     1 A4,1X,A1,I4,' NOT generated - allowed atom absence')
1200	FORMAT (' ','POLH_GEN is done: ',I5,' residues read and ',
     1 I5,' polar hydrogen atoms generated')

9000	FORMAT ('0','*** ERROR * hyd_gen * too many atoms is residue')
9100	FORMAT ('0','*** ERROR * hyd_gen * atyp_i/hgen ne root atyp')
9200	FORMAT ('0','*** ERROR * hyd_gen * n_buf ott with added numb')
9300	FORMAT ('0','*** ERROR * hyd_gen * hgen root mismatch')

	ir_read		= 0
	ih_made		= 0
	end_of_file	= .FALSE.
200	ir_read		= ir_read + 1
	CALL	read_residue (end_of_file)
	res		= buf_res (1,2)
	CALL	res_id (res, irt, ia_1, ia_2, na)
	IF (n_buf (2) .GT. na) GOTO 900
	DO 500 ia	= 1, n_buf (2)
	  atyp		= buf_atyp (ia,2)
	  common_at	= .FALSE.
	  DO 240 i_com	= 1, n_common
	    IF (atyp .EQ. common_atyp (i_com)) THEN
	      iat	= common_pter (i_com)
	      common_at	= .TRUE.
	    END IF
240	  CONTINUE						! End i_com
	  IF (.NOT. common_at) THEN
	    CALL	atom_id (atyp, iat, ia_1,ia_2)
	  END IF
	  IF (at_hgen (iat)) THEN
	    ihg		= at_hgen_pter (iat)
	    atyp_i	= hgen_char (ihg,1)
	    irel_i	= hgen_int (ihg,2)
	    IF (atyp_i .NE. atyp) GOTO 910
	    CALL	get_ords (atyp_i, irel_i, xyz_i, ords_absent)
	    IF (ords_absent) THEN
	      WRITE (9,1100) atyp,res,buf_chain (1,2),buf_nres (1,2)
	      IF (remove_base) THEN
		nres_this	= buf_nres (1,2)
		chain_this	= buf_chain (1,2)
		CALL	check_remove (atyp, res, nres_this,chain_this)
	      ELSE
		CALL	write_atom (ia, 2)
	      END IF
	      GOTO 500
	    END IF
	    atyp_j	= hgen_char (ihg,2)
	    irel_j	= hgen_int (ihg,3)
	    CALL	get_ords (atyp_j, irel_j, xyz_j, ords_absent)
	    IF (ords_absent) THEN
	      WRITE (9,1100) atyp,res,buf_chain (1,2),buf_nres (1,2)
	      IF (remove_base) THEN
		nres_this	= buf_nres (1,2)
		chain_this	= buf_chain (1,2)
		CALL	check_remove (atyp, res, nres_this,chain_this)
	      ELSE
		CALL	write_atom (ia, 2)
	      END IF
	      GOTO 500
	    END IF
	    atyp_k	= hgen_char (ihg,3)
	    irel_k	= hgen_int (ihg,4)
	    CALL	get_ords (atyp_k, irel_k, xyz_k, ords_absent)
	    IF (ords_absent) THEN
	      WRITE (9,1100) atyp,res,buf_chain(1,2),buf_nres (1,2)
	      IF (remove_base) THEN
		nres_this	= buf_nres (1,2)
		chain_this	= buf_chain (1,2)
		CALL	check_remove (atyp, res, nres_this,chain_this)
	      ELSE
		CALL	write_atom (ia, 2)
	      END IF
	      GOTO 500
	    END IF
	    CALL	write_atom (ia, 2)
	    code	= hgen_int (ihg,1)
	    numb	= hgen_int (ihg,5)
	    bond	= hgen_real (ihg,1)
	    angle	= hgen_real (ihg,2)
	    CALL	hyd_ords (xyz_i,xyz_j,xyz_k, code,numb,
     1				  bond,angle, xyz_hyd)
	    n_test	= n_buf (2) + numb
	    IF (n_test .GT. 100) GOTO 920
	    IF (write_gen) THEN
	    WRITE (9,1040) numb,atyp,res,buf_chain(1,2),buf_nres (1,2)
	    END IF
	    DO 400 iho			= 1, numb
	      is			= n_buf (2) + iho
	      DO 300 n			= 1, 3
		buf_xyz (is,n,2)	= xyz_hyd (iho,n)
300	      CONTINUE						! End n
	      buf_atom (is,2)		= 'ATOM'
	      buf_res (is,2)		= res
	      IF (at_hgen_root (iat+iho) .NE. atyp) GOTO 930
	      buf_atyp (is,2)		= at_type (iat+iho)
	      buf_nres (is,2)		= buf_nres (1,2)
	      buf_chain (is,2)		= buf_chain (1,2)
	      ih_made			= ih_made + 1
	      CALL	write_atom (is, 2)
	      IF (write_gen) THEN
		WRITE (9,1050) buf_atyp(is,2),(buf_xyz(is,n,2),n=1,3)
	      END IF
400	    CONTINUE						! End i
	  ELSE
	    CALL	write_atom (ia, 2)
	  END IF
500	CONTINUE						! End ia
	IF (first_res) first_res =.FALSE.
	IF (end_of_file) THEN
	  GOTO 700
	ELSE
	  GOTO 200
	END IF

700	CLOSE (UNIT=1)
	CLOSE (UNIT=2)
	WRITE (9,1010) spacer
	WRITE (9,1200) ir_read, ih_made
	WRITE (9,1010) spacer
	CLOSE (UNIT=9)
	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT

920	WRITE (6,9200)
	CALL	EXIT

930	WRITE (6,9300)
	CALL	EXIT
	END


C-----------------------------------------------------------------------------C
C									      C
C		SUBROUTINE	write_atom				      C
C									      C
C-----------------------------------------------------------------------------C

	SUBROUTINE	write_atom (is, ib)
C	**********	**********

C Write out the atom in slot is of buffer ib.

	CHARACTER*4	buf_atyp (100,2), buf_res (100,2),
     1			buf_atom (100,2)
	REAL		buf_xyz (100,3,2)
	INTEGER		buf_nres (100,2), n_buf (2)
	CHARACTER*1	buf_chain (100,2), chain_here
	CHARACTER*80	atom_record
	CHARACTER*4	atyp_here, res_here
	LOGICAL		first_res, first_atom

	COMMON	/coord_buf/	buf_atyp, buf_res, buf_xyz,
     1				buf_atom, buf_nres, first_res,
     2				atom_record, n_buf, first_atom,
     3				buf_chain

1020	FORMAT (A4, 9X, A4, A4, A1, I4, 4X, 3F8.3)
1300	FORMAT ('0',' For atyp,res ',A4,2X,A4,' nres has been
     1 downdated to ',A1,I4,' on o/p')

	nres_here	= buf_nres (is,ib)
	atyp_here	= buf_atyp (is,ib)
	res_here	= buf_res (is,ib)
	chain_here	= buf_chain (is,ib)
	IF ((atyp_here.EQ.'NT  ') .OR. (atyp_here.EQ.'NT1 ')) THEN
	  nres_here	= nres_here - 1
	  WRITE (9,1300) atyp_here, res_here, chain_here, nres_here
	END IF
	IF ((atyp_here.EQ.'HT1 ') .OR. (atyp_here.EQ.'HT2 ') .OR.
     1	    (atyp_here.EQ.'HT3 ')) THEN
	  nres_here	= nres_here - 1
	  WRITE (9,1300) atyp_here, res_here, chain_here, nres_here
	END IF
	IF ((atyp_here.EQ.'HTN1') .OR. (atyp_here.EQ.'HTN2')) THEN
	  nres_here	= nres_here - 1
	  WRITE (9,1300) atyp_here, res_here, chain_here, nres_here
	END IF

	WRITE (2,1020) buf_atom (is,ib), buf_atyp (is,ib),
     1		       buf_res (is,ib), buf_chain(is,ib),nres_here,
     2		      (buf_xyz (is,n,ib), n=1,3)
	RETURN
	END


C-----------------------------------------------------------------------------C
C									      C
C		SUBROUTINE	get_ords				      C
C									      C
C-----------------------------------------------------------------------------C

	SUBROUTINE	get_ords (atyp, irel, xyz, ords_absent)
C	**********	********

C Return the ordinates (xyz) for atom (atyp) of relative residue (irel),
C in the residue buffer arrays.

	REAL		xyz (3)
	CHARACTER*4	buf_atyp (100,2), buf_res (100,2),
     1			buf_atom (100,2)
	REAL		buf_xyz (100,3,2)
	INTEGER		buf_nres (100,2), n_buf (2)
	CHARACTER*1	buf_chain (100,2)
	CHARACTER*4	atyp
	CHARACTER*80	atom_record
	LOGICAL		first_res, first_atom
	LOGICAL		ords_absent, skip_irel, skip_absent,
     1			remove_base

	COMMON	/coord_buf/	buf_atyp, buf_res, buf_xyz,
     1				buf_atom, buf_nres, first_res,
     2				atom_record, n_buf, first_atom,
     3				buf_chain
	COMMON	/skips/		skip_irel, skip_absent, remove_base

9000	FORMAT ('0','*** ERROR * get_ords * relative residue wrong')
9100	FORMAT ('0','*** ERROR * get_ords * first_res/irel = -1')
9200	FORMAT ('0','*** ERROR * get_ords * atyp for hgen not found')

	ords_absent	= .FALSE.

	IF	(irel .EQ. -1) THEN
	  IF (first_res) THEN
	    IF (skip_irel) THEN
	      ords_absent	= .TRUE.
	      RETURN
	    ELSE
	      GOTO 910
	    END IF
	  ELSE
	    ib		= 1
	  END IF
	ELSE IF (irel .EQ. 0) THEN
	  ib		= 2
	ELSE
	  GOTO 900
	END IF

	DO 300 i	= 1, n_buf (ib)
	  IF (atyp .EQ. buf_atyp (i,ib)) THEN
	    DO 200 n	= 1, 3
	      xyz (n)	= buf_xyz (i,n,ib)
200	    CONTINUE						! End n
	    RETURN
	  END IF
300	CONTINUE						! End i
	IF (skip_absent) THEN
	  ords_absent	= .TRUE.
	  RETURN
	ELSE
	  WRITE (6,9200)
	END IF
	CALL	EXIT

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT
	END


C-----------------------------------------------------------------------------C
C									      C
C		SUBROUTINE	hyd_ords				      C
C									      C
C-----------------------------------------------------------------------------C

	SUBROUTINE	hyd_ords (xyz_i,xyz_j,xyz_k, code,numb,
C	**********	********
     1				  bond,angle, xyz_hyd)

C Return coordinates for numb hydrogen atoms, in xyz_hyd, generated
C according to code.

	REAL		xyz_i (3), xyz_j (3), xyz_k (3),xyz_hyd (3,3),
     1			u (3), v (3), uv (3), uv_unit (3), u_unit (3),
     2			v_unit (3), p_zero (3), p (3),p_mat_inv (3,3),
     3			new_axes (3,3), DC_1 (3,3), DC_2 (3,3),
     4			rot_mat (3,3), p_1 (3), p_2 (3), p_3 (3),
     5			p_mat (3,3)
	INTEGER		code
	LOGICAL*1	singular

9000	FORMAT ('0','*** ERROR * hyd_ords * no. of hyd atoms mismatch')
9100	FORMAT ('0','*** ERROR * hyd_ords * singular 3x3 matrix')
9200	FORMAT ('0','*** ERROR * hyd_ords * hgen code not recognised')

	IF	(code .EQ. 1) THEN
	  IF (numb .NE. 1) GOTO 900
	  CALL	vec_sub (xyz_j, xyz_i, u)
	  CALL	vec_sub (xyz_k, xyz_i, v)
	  CALL	unit_vec (u, u_unit, u_mag)
	  CALL	unit_vec (v, v_unit, v_mag)
	  CALL	vec_add (u_unit, v_unit, uv)
	  CALL	unit_vec (uv, uv_unit, uv_mag)
	  DO 200 n		= 1, 3
	    xyz_hyd (1,n)	= xyz_i (n) - bond*uv_unit (n)
200	  CONTINUE						! End n
	  RETURN
	ELSE IF ((code .GE. 2) .AND. (code .LE. 5)) THEN
	  CALL	vec_sub (xyz_j, xyz_i, u)
	  CALL	vec_sub (xyz_k, xyz_j, v)
	  CALL	unit_vec (u, u_unit, u_mag)
	  CALL	unit_vec (v, v_unit, v_mag)
	  CALL	vec_cross (u, v, uv)
	  CALL	vec_dot (u, v, uv_dot)
	  p_zero (1)	= 0.

	  angle_rads = (angle*3.14159)/180.
	  p_zero (2)	= bond*u_mag*COS (angle_rads)
Clnx	  p_zero (2)	= bond*u_mag*COSD (angle)

	  DO 240 n	= 1, 3
	    p_mat (1,n)	= uv (n)
	    p_mat (2,n)	= u (n)
	    p_mat (3,n)	= v (n)
240	  CONTINUE						! End n
	  CALL	INVERT3 (p_mat, p_mat_inv, determinant, singular)
	  IF (singular) GOTO 910

Clnx	  ang_uv	= ACOSD ((-1.*uv_dot/(u_mag*v_mag)))
	  ang_uv_rads	= ACOS ((-1.*uv_dot/(u_mag*v_mag)))
	  ang_uv	= (ang_uv_rads*180.)/3.14159

	  ang_pv	= angle + 180. - ang_uv

	  ang_pv_rads	= (ang_pv*3.14159)/180.
	  p_zero (3)	= bond*v_mag*COS (ang_pv_rads)
Clnx	  p_zero (3)	= bond*v_mag*COSD (ang_pv)

	  CALL	mult_mat_vec (p_mat_inv, p_zero, p)
	  DO 300 n		= 1, 3
	    xyz_hyd (1,n)	= xyz_i (n) + p (n)
300	  CONTINUE						! End n
	  IF      (code .EQ. 2) THEN
	    IF (numb .NE. 1) GOTO 900
	    RETURN
	  ELSE IF (code .EQ. 3) THEN
	    IF (numb .NE. 2) GOTO 900
	    ang_pv	= angle + ang_uv - 180.

	    ang_pv_rads	= (ang_pv*3.14159)/180.
	    p_zero (3)	= bond*v_mag*COS (ang_pv_rads)
Clnx	    p_zero (3)	= bond*v_mag*COSD (ang_pv)

	    CALL	mult_mat_vec (p_mat_inv, p_zero, p)
	    DO 400 n		= 1, 3
	      xyz_hyd (2,n)	= xyz_i (n) + p (n)
400	    CONTINUE						! End n
	  ELSE IF ((code .EQ. 4) .OR. (code .EQ. 5)) THEN
	    DO 420 n	= 1, 3
	      p_1 (n)	= xyz_hyd (1,n)
420	    CONTINUE						! End n
	    CALL	new_axes_gen (u, new_axes)
	    CALL	DC_get (new_axes, DC_1)
	    CALL	INVERT3 (DC_1, DC_2, determinant, singular)
	    IF (singular) GOTO 910
	    CALL	rot_mat_x (120., rot_mat)
	    CALL	roll_point (p_1, p_2, xyz_i,DC_1,DC_2,rot_mat)
	    DO 440 n		= 1, 3
	      xyz_hyd (2,n)	= p_2 (n)
440	    CONTINUE						! End n
	    IF      (code .EQ. 4) THEN
	      IF (numb .NE. 3) GOTO 900
	      CALL	rot_mat_x (240., rot_mat)
	      CALL	roll_point (p_1, p_3, xyz_i,DC_1,DC_2,rot_mat)
	      DO 460 n		= 1, 3
		xyz_hyd (3,n)	= p_3 (n)
460	      CONTINUE						! End n
	      RETURN
	    ELSE IF (code .EQ. 5) THEN
	      IF (numb .NE. 2) GOTO 900
	      RETURN
	    END IF
	  END IF
	ELSE
	  GOTO 920
	END IF

	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT

920	WRITE (6,9200)
	CALL	EXIT
	END


C-----------------------------------------------------------------------------C
C									      C
C		SUBROUTINE	check_remove				      C
C									      C
C-----------------------------------------------------------------------------C

	SUBROUTINE	check_remove (atyp,res,nres_this,chain_this)
C	**********	************

C ?? herejim - may need to put more checks in here for dipolar groups that
C              go further back than the hydrogen generation atom.

	CHARACTER*4	atyp, res
	CHARACTER*1	chain_this

1120	FORMAT (' ','base atom ',A4,1X,A4,1X,A1,I4,' removed from
     1 output file - cannot make hydrogens')
1130	FORMAT (' ','base atom ',A4,1X,A4,1X,A1,I4,' ******** IS NOT
     1 the total dipolar group here ******')

	WRITE (9,1120) atyp, res, chain_this, nres_this
	IF	(res .EQ. 'SER ' .AND. atyp .EQ. 'OG  ') THEN
	  WRITE (9,1130) atyp, res, chain_this, nres_this
	ELSE IF (res .EQ. 'THR ' .AND. atyp .EQ. 'OG1 ') THEN
	  WRITE (9,1130) atyp, res, chain_this, nres_this
	ELSE IF (res .EQ. 'TRP ' .AND. atyp .EQ. 'NE1 ') THEN
	  WRITE (9,1130) atyp, res, chain_this, nres_this
	ELSE IF (res .EQ. 'TYR ' .AND. atyp .EQ. 'OH  ') THEN
	  WRITE (9,1130) atyp, res, chain_this, nres_this
	ELSE IF (res .EQ. 'TYRH' .AND. atyp .EQ. 'OH  ') THEN
	  WRITE (9,1130) atyp, res, chain_this, nres_this
	END IF

	RETURN
	END


C-----------------------------------------------------------------------------C
C									      C
C		SUBROUTINE	vec_sub					      C
C									      C
C-----------------------------------------------------------------------------C

	SUBROUTINE	vec_sub (a, b, c)
C	**********	*******

	REAL		a (3), b (3), c (3)

	DO 200 n	= 1, 3
	  c (n)		= a (n) - b (n)
200	CONTINUE
	RETURN
	END


C-----------------------------------------------------------------------------C
C									      C
C		SUBROUTINE	vec_add					      C
C									      C
C-----------------------------------------------------------------------------C

	SUBROUTINE	vec_add (a, b, c)
C	**********	*******

	REAL		a (3), b (3), c (3)

	DO 200 n	= 1, 3
	  c (n)		= a (n) + b (n)
200	CONTINUE
	RETURN
	END


C-----------------------------------------------------------------------------C
C									      C
C		SUBROUTINE	unit_vec				      C
C									      C
C-----------------------------------------------------------------------------C

	SUBROUTINE	unit_vec (x, x_unit, x_mag)
C	**********	********

	REAL		x (3), x_unit (3)

	x_mag		= SQRT (x(1)*x(1) + x(2)*x(2) + x(3)*x(3))
	DO 200 n	= 1, 3
	  x_unit (n)	= x (n) / x_mag
200	CONTINUE						! End n
	RETURN
	END


C-----------------------------------------------------------------------------C
C									      C
C		SUBROUTINE	vec_cross				      C
C									      C
C-----------------------------------------------------------------------------C

	SUBROUTINE	vec_cross (a, b, acb)
C	**********	*********

	REAL		a (3), b (3), acb (3)

	acb (1)		= a (2)*b (3) - a (3)*b (2)
	acb (2)		= a (3)*b (1) - a (1)*b (3)
	acb (3)		= a (1)*b (2) - a (2)*b (1)
	RETURN
	END


C-----------------------------------------------------------------------------C
C									      C
C		SUBROUTINE	vec_dot					      C
C									      C
C-----------------------------------------------------------------------------C

	SUBROUTINE	vec_dot (a, b, dot)
C	**********	*******

	REAL		a (3), b (3)

	dot		= a (1)*b (1) + a (2)*b (2) + a (3)*b (3)
	RETURN
	END


C-----------------------------------------------------------------------------C
C									      C
C		SUBROUTINE	mult_mat_vec				      C
C									      C
C-----------------------------------------------------------------------------C

	SUBROUTINE	mult_mat_vec (a, b, c)
C	**********	************

	REAL		a (3,3), b (3), c (3)

	DO 300 i	= 1, 3
	  c (i)		= 0.
	  DO 300 j	= 1, 3
	    c (i)	= c (i) + a (i,j)* b (j)
300	CONTINUE						! End j,i
	RETURN
	END


	SUBROUTINE INVERT3 ( A, AINV, ADET, SING )
C	********** *******

C@@@@@@  Test this Routine  LATER !! @@@@@@

C This routine returns the matrix inverse of A in AINV, the determinant of
C A (ADET), and sets SING = .true. if A is singular.
C See J.W., p.C3, Mathematics for Chemists.

C n.b. This is programmed for a 3*3 matrix.

	REAL A (3,3), AINV (3,3), T (3,3,3), DET (3)
	LOGICAL*1	SING

	DO 210 I = 1, 3
	    DO 200 J = 1, 3
		T (1,I,J) = A (I,J)
200	    CONTINUE						! End J
210	CONTINUE						! End I

	DO 550 I1 = 1, 3
	    IF ( I1 .EQ. 1 ) DET (1) = 0.
	    DO 500 J1 = 1, 3
		CALL STRIKE ( T, I1, J1, 1, 3 )
		DET (2) = 0.
		DO 450 J2 = 1, 2
		    CALL STRIKE ( T, 1, J2, 2, 2 )
		    DET (3) = T (3,1,1)
		    ISN = 1
		    IF ( MOD (1+J2,2) .NE. 0 ) ISN = -1
		    SN = FLOAT (ISN)
		    DET (2) = DET (2) + SN * T (2,1,J2) * DET (3)
450		CONTINUE					! End J2
		ISN = 1
		IF ( MOD (I1+J1,2) .NE. 0 ) ISN = -1
		SN = FLOAT (ISN)
		IF ( I1 .EQ. 1 )
     1          DET (1) = DET (1) + SN * T (1,I1,J1) * DET (2)
		AINV (J1,I1) = SN * DET (2)
500	    CONTINUE						! End J1
550	CONTINUE						! End I1

	ADET = DET (1)
	SING = .FALSE.
	IF ( ADET .EQ. 0. ) SING = .TRUE.
	IF ( SING ) RETURN

	DO 610 I = 1, 3
	    DO 600 J = 1, 3
		AINV (I,J) = AINV (I,J) / ADET
600	    CONTINUE						! End J
610	CONTINUE						! End I

	RETURN
	END


	SUBROUTINE STRIKE ( T, I, J, L, N )
C	********** ******

C This routine strikes out the i row and j column of the matrix (of order N)
C in the L level of T, and inserts the result (order N-1) in the L+1 level
C of T.

	REAL T (3,3,3)

	IF ( L+1 .GT. 3 ) STOP 'T array l+1 .gt. 3'
	IVV = 0
	DO 210 IV = 1, N
	    IF ( IV .EQ. I ) GOTO 210
	    IVV = IVV + 1
	    JVV = 0
	    DO 200 JV = 1, N
		IF ( JV .EQ. J ) GOTO 200
		JVV = JVV + 1
		T (L+1,IVV,JVV) = T (L,IV,JV)
200	    CONTINUE						! End Jv
210	CONTINUE						! End Iv

	RETURN
	END


	SUBROUTINE	new_axes_gen (R, new_axes)
C	**********	************

C This routine works out a r-h axis system s.t. the point R on regular
C (xyz) system is transformed to (mod(R),0,0) in the new system.
C new_axes (3,3) records the components of the new system in (xyz).
C ?? See JW notes.

	REAL		R (3), new_axes (3,3), mag_vec, unit_vc (3),
     1			mu_jw, lambda_jw, A (3), B (3), C (3)

C First the new x axis simply is the normalised R vector on old (xyz).

	CALL	unit_vec (R, unit_vc, mag_vec)
	DO 200 n = 1, 3
	  new_axes (1,n)	= unit_vc (n)
200	CONTINUE						! End n

C Now we choose the new y to be coplanar with new x and old y, (see JW notes).

	mu_jw		= SQRT (1./(1.-new_axes(1,2)*new_axes(1,2)))
	lambda_jw	= -mu_jw * new_axes (1,2)

	new_axes (2,1)	= lambda_jw * new_axes (1,1)
	new_axes (2,2)	= lambda_jw * new_axes (1,2) + mu_jw
	new_axes (2,3)	= lambda_jw * new_axes (1,3)

C And the new z is generated so as to give a right-handed set.

	DO 400 n = 1, 3
	  A (n)			= new_axes (1,n)
	  B (n)			= new_axes (2,n)
400	CONTINUE						! End n
	CALL	vec_cross (A, B, C)
	DO 500 n = 1, 3
	  new_axes (3,n)	= C (n)
500	CONTINUE						! End n
	RETURN
	END


	SUBROUTINE	DC_get (new_axes, DC)
C	**********	******

C Routine returns the direction cosine matrix (DC) that transforms coords
C between normal (xyz) system and axial system with components on normal
C (xyz) given in new_axes array.

	REAL		new_axes (3,3), DC (3,3), new_ax (3),
     1			old_axes (3,3), old_ax (3)

	DATA	old_axes(1,1),old_axes(1,2),old_axes(1,3) /1.,0.,0./
	DATA	old_axes(2,1),old_axes(2,2),old_axes(2,3) /0.,1.,0./
	DATA	old_axes(3,1),old_axes(3,2),old_axes(3,3) /0.,0.,1./

	DO 300 l = 1, 3
	  DO 200 n = 1, 3
	    new_ax (n)		= new_axes (l,n)
200	  CONTINUE						! End n
	  DO 300 m = 1, 3
	    DO 250 n = 1, 3
	      old_ax (n)	= old_axes (m,n)
250	    CONTINUE						! End n
	    CALL	vec_dot (new_ax, old_ax, dot)
	    DC (l,m)		= dot
300	CONTINUE						! End m,l
	RETURN
	END


	SUBROUTINE	rot_mat_x (angle, rot_mat)
C	**********	*********

C Routine returns rotation matrix for rotn of angle about x axis.
C ?? Patriots : in a hurry : look this up : just definition anyway

	REAL		rot_mat (3,3)

Clnx	c_angle		= COSD (angle)
Clnx	s_angle		= SIND (angle)
	angle_rads	= (angle*3.14159)/180.
	c_angle		= COS (angle_rads)
	s_angle		= SIN (angle_rads)

	rot_mat (1,1)	= 1.
	rot_mat (1,2)	= 0.
	rot_mat (1,3)	= 0.
	rot_mat (2,1)	= 0.
	rot_mat (2,2)	=  c_angle
	rot_mat (2,3)	= -s_angle
	rot_mat (3,1)	= 0.
	rot_mat (3,2)	=  s_angle
	rot_mat (3,3)	=  c_angle
	RETURN
	END


	SUBROUTINE	roll_point (xyz, xyz_new, a_ax, DC_1, DC_2,
C	**********	**********
     1				    rot_mat)

C Routine performs rotation about axis that has been encoded into the
C matrices passed.
C See JW notes for the transformation, involving the dirn cosine matrices.

	REAL		xyz (3), xyz_new (3), a_ax (3), DC_1 (3,3),
     1			DC_2 (3,3), rot_mat (3,3), tmp_1 (3),
     2			tmp_2 (3), tmp_3 (3), tmp_4 (3)

C ?? Patriots : can we not concatenate these matrix operations?

	sign	= -1.
	CALL vec_trn		(xyz, a_ax, tmp_1, sign)
	CALL	mult_mat_vec (DC_1, tmp_1, tmp_2)
	CALL	mult_mat_vec (rot_mat, tmp_2, tmp_3)
	CALL	mult_mat_vec (DC_2, tmp_3, tmp_4)
	sign	=  1.
	CALL vec_trn		(tmp_4, a_ax, xyz_new, sign)
	RETURN
	END


	SUBROUTINE	vec_trn (A, B, C, sign)
C	**********	*******

C Vector translation, C = A + sign*B

	REAL		A (3), B (3), C (3)

	DO 200 n = 1, 3
	  C (n)		= A (n) + sign * B (n)
200	CONTINUE						! End n
	RETURN
	END


	SUBROUTINE	get_filename (rec, file)
C	**********	************

C Remove leading blanks from file name.

	CHARACTER*80	rec, file
	LOGICAL		started

	DO 180 i	= 1, 80
	  file (i:i)	= ' '
180	CONTINUE						! End i

	n		= 1
	started		= .FALSE.
	DO 200	i	= 1, 80
	  IF (rec (i:i) .EQ. ' ') THEN
	    IF (started) GOTO 300
	  ELSE
	    started	= .TRUE.
	    file (n:n)	= rec (i:i)
	    n		= n + 1
	  END IF
200	CONTINUE						! End i

300	CONTINUE
	RETURN
	END

