
C Make our solvent accessibility routine, written originally for escalc, into
C a general SA (per residue) routine, with PDB input.
C Atoms limit is currently 100000.

C SA_CALC from SA_CALCULATE with changes below:

C Updated Jan 2002:	to skip non-atom records
C			to skip H atoms
C			to divide into polar (NOSP) and non-polar(C)
C			to sum according to chain
C Updated June 2002:	to divide C atoms into those which are/not polar
C			based on partial charge

	REAL	AT (100000,4),XYZC (3),XYZ (3),XYZMIN (3),XYZMAX (3)
	INTEGER ATBOX (100001), BOX (35,35,35,2), IJKM (3), IJK (3),
     1          IJKC (3), IJK1 (3), IJK2 (3)
	CHARACTER*4	at_residue (100000), res_last,
     1			at_atyp (100000)
	INTEGER	at_nresidue (100000), res_index (10000,2),
     1		at_model (100000)
	BYTE	at_chainid (100000), chain_last
	LOGICAL	at_polar (100000), at_mc (100000),
     1		at_semipolar (100000), at_nonpolar (100000)
	INTEGER		which_VdW
	CHARACTER*80	line
	BYTE		header (80), chain
	REAL		at_VdW (100,10), at_chrg (2000,4),
     1			at_pK (2000)
	CHARACTER*4	res_type (200), at_type (2000),
     1			common_atyp (100), at_prtner (2000)
	INTEGER		n_res_ats (200), nat_pter (200,2),
     1			at_class (2000), common_pter (100)
	CHARACTER*34	at_info (100)
	LOGICAL*1	at_anyq (2000), at_ionise (2000), common_at
	LOGICAL		FREE (720)
	CHARACTER*60	probe_radius, keep_model, reunite_term,
     1			atom_output
	LOGICAL		keep_mdl, reunite_terms, atoms_out

	CHARACTER*4	atm, res, atyp, res_semi (6), atyp_semi (6)
	CHARACTER*5	atyp_buf
	CHARACTER*2	mc_sc_code
Clnx	REAL		res_real, atyp_real
Clnx	EQUIVALENCE	(res, res_real)
Clnx	EQUIVALENCE	(atyp, atyp_real)

	COMMON /BOXGRD/ XYZMIN, XYZMAX, STEP, IJKM
	COMMON	/atoms_es_type/ at_info, n_at_types, at_VdW, n_VdW
	COMMON	/atoms_es_resi/	n_res_types, n_chrg, n_all_at,
     1				res_type, n_res_ats, nat_pter,
     2				at_type, at_class, at_chrg,
     3				at_anyq, at_ionise, at_pK,
     4				at_prtner
	COMMON	/common_atoms/	common_atyp, common_pter, n_common
	COMMON	/at_props/	at_polar, at_mc, at_semipolar,
     1				at_nonpolar

	DATA	res_semi /'ARG ','ASN ','ASP ','GLN ','GLU ','HIS '/
	DATA   atyp_semi /'CZ  ','CG  ','CG  ','CD  ','CD  ','CE1 '/

	n_semi	= 6

C Link with the atoms_dat.for routines for picking-up and assigning atom/res
C types etc.

	CALL	read_atoms_es

C Various parameters:
C Nov. 2002 - we will set of RPROBE from env variable, if found.

	PI		= 3.14159
	which_VdW	= 1
	NANG		= 180
	PLNDIV		= 0.5

	RPROBE		= 1.4
	CALL	GETENV ('PROBE_RADIUS', probe_radius)
	CALL	leader (probe_radius, ipr)
	IF (ipr .NE. 0) THEN
	  READ (probe_radius(1:ipr),*) RPROBE
	END IF

	CALL	GETENV ('KEEP_MODEL', keep_model)
	CALL	leader (keep_model, ikm)
	IF	(keep_model (1:1) .EQ. 'T') THEN
	  keep_mdl	= .TRUE.
	ELSE
	  keep_mdl	= .FALSE.
	END IF

	CALL	GETENV ('REUNITE_TERMS', reunite_term)
	CALL	leader (reunite_term, irt)
	IF	(reunite_term (1:1) .EQ. 'T') THEN
	  reunite_terms	= .TRUE.
	ELSE
	  reunite_terms	= .FALSE.
	END IF

	CALL	GETENV ('ATOM_OUTPUT', atom_output)
	CALL	leader (atom_output, iao)
	IF	(atom_output (1:1) .EQ. 'T') THEN
	  atoms_out	= .TRUE.
	ELSE
	  atoms_out	= .FALSE.
	END IF

1020	FORMAT (80A1)
C??atyp	1030	FORMAT (A4,9X,A4,A4,A1,I4,4X,3F8.3)
1032	FORMAT (A4, 8X,         A5, A4, A1, I4, 4X, 3F8.3)
1034	FORMAT (A4, 2X, I5, 1X, A5, A4, A1, I4, 4X, 3F8.3)
1035	FORMAT (' ',20X,'Solvent Accessibility by residue')
1037	FORMAT (' ',20X,'Solvent Accessibility by residue and atom')
1040	FORMAT (' ','chain nres res  SA (Asq) :
     1  tot      plr     nplr     nplr#     mc       sc  MDL')
1050	FORMAT (' ','chain nres res  SA (Asq) :
     1  tot      plr     nplr     nplr#     mc       sc')
1055	FORMAT (' ','chain nres res  SA (Asq) :
     1  tot      plr     nplr     nplr#     mc       sc  MCSC ATOM',
     1'  POLAR  NONPOLAR')
1060	FORMAT ('>',1X,A1,3X,I4,2X,A4,8X,6(F8.1,1X),I3)
1070	FORMAT ('>',1X,A1,3X,I4,2X,A4,8X,6(F8.1,1X))
1075	FORMAT ('Z',1X,A1,3X,I4,2X,A4,' sc np  ',3(F8.1,1X))
1080	FORMAT (' SA TOTALS (Asq) =      ',6(F8.1,1X),/,
     1'for PROBE_RADIUS =  ',F5.2,
     2'  total    polar nonpolar nonpolar# mainchn  sidechn')
1090	FORMAT (A80)
1100	FORMAT (A4)
2020	FORMAT ('A',1X,A1,3X,I4,2X,A4,64X,A2,2X,A4,1X,2(F6.1,1X))

	TWOPI = 2. * PI
	IATM = 0
	RMAX = 0.

	DANG = TWOPI / ( FLOAT (NANG) )

	DO 170 N = 1, 3
	    XYZMIN (N) =  100000.
	    XYZMAX (N) = -100000.
170	CONTINUE

C Read coordinates into array, marking residues, and assigning atomic radii.
C ?? Updated 28/Aug/01 to read atyp field from one further char to left, if it
C ?? has something there - otherwise fill up to left as do currently.

	OPEN(UNIT=1,NAME='sa_calc.in',TYPE='OLD')
CJan02	READ(1,1020) header

220	CONTINUE
C??atyp	READ (1,1030,END=300) atm,atyp,res,chain,NCUR,XYZ
	READ (1,1090,END=300) line
	READ (line,1100) atm
	IF ( atm .NE. 'ATOM' .AND. atm .NE. 'HETA' ) GOTO 220
	IF (keep_mdl) THEN
	  READ (line,1034) atm,n_model,atyp_buf,res,chain,NCUR,XYZ
	ELSE
	  READ (line,1032) atm,atyp_buf,res,chain,NCUR,XYZ
	END IF

	IF (atyp_buf (2:2) .EQ. 'H') GOTO 220

	IF (atyp_buf (1:1) .EQ. ' ') THEN
	  atyp (1:4) = atyp_buf (2:5)
	ELSE
	  atyp (1:4) = atyp_buf (1:4)
	END IF

	IF (reunite_terms) THEN
	  IF (atyp .EQ. 'NT  ') THEN
	    IF (NCUR .NE. 0) STOP 'NCUR NT 0 - sa_calc'
	    NCUR=NCUR + 1
	  END IF
	  IF (atyp .EQ. 'CT  ') NCUR=NCUR-1
	  IF (atyp .EQ. 'OT1 ') NCUR=NCUR-1
	  IF (atyp .EQ. 'OT2 ') NCUR=NCUR-1
	END IF

	    DO 270 N = 1, 3
		IF ( XYZ (N) .LT. XYZMIN (N) ) XYZMIN (N) = XYZ (N)
		IF ( XYZ (N) .GT. XYZMAX (N) ) XYZMAX (N) = XYZ (N)
270	    CONTINUE

	common_at	= .FALSE.
	DO 280 i_com	= 1, n_common
C??	  IF (atyp_real .EQ. common_atyp (i_com)) THEN
	  IF (atyp .EQ. common_atyp (i_com)) THEN
	    iat		= common_pter (i_com)
	    common_at	= .TRUE.
	  END IF
280	CONTINUE						! End i_com
	IF (.NOT. common_at) THEN
Clnx	  CALL	res_id (res_real, irt, ia_1, ia_2, na)
Clnx	  CALL	atom_id (atyp_real, iat, ia_1, ia_2)
	  CALL	res_id (res, irt, ia_1, ia_2, na)
	  CALL	atom_id (atyp, iat, ia_1, ia_2)
	END IF
	    ic		= at_class (iat)
	    rad		= at_VdW (ic,which_VdW)

	    IF ( RAD .LT. 0.55 ) STOP 'RAD < 0.55 A'
	    IF ( RAD .GT. RMAX ) RMAX = RAD

	    IATM = IATM + 1

	    IF (atoms_out) THEN
	      at_atyp (IATM)	= atyp
	    END IF

	    IF ( IATM .GT. 100000 ) STOP 'IATM > 100000'
	    AT (IATM,1) = XYZ (1)
	    AT (IATM,2) = XYZ (2)
	    AT (IATM,3) = XYZ (3)
	    AT (IATM,4) = RAD
	    at_residue (IATM) = res
	    at_nresidue (IATM) = NCUR
	    at_chainid (IATM) = chain
	    IF (keep_mdl) at_model (IATM) = n_model

	    IF (atyp (1:1) .EQ. 'C') THEN
	      at_polar (IATM)		= .FALSE.
	      IF ( (atyp (1:4) .EQ. 'CT  ') .OR.
     1		   (atyp (1:4) .EQ. 'C   ') ) THEN
		at_semipolar (IATM)	= .TRUE.
		at_nonpolar (IATM)	= .FALSE.
		GOTO 295
	      END IF
	      DO 290 i_semi	= 1, n_semi
		IF ( (res (1:4) .EQ. res_semi (i_semi)) .AND.
     1		     (atyp (1:4) .EQ. atyp_semi (i_semi)) ) THEN
		  at_semipolar (IATM)	= .TRUE.
		  at_nonpolar (IATM)	= .FALSE.
		  GOTO 295
		END IF
290	      CONTINUE						! End i_semi
	      at_semipolar (IATM)	= .FALSE.
	      at_nonpolar (IATM)	= .TRUE.
	    ELSE
	      at_polar (IATM)		= .TRUE.
	      at_semipolar (IATM)	= .FALSE.
	      at_nonpolar (IATM)	= .FALSE.
	    END IF

295	    CONTINUE
	    IF      (atyp (1:2) .EQ. 'N ') THEN
	      at_mc (IATM)	= .TRUE.
	    ELSE IF (atyp (1:2) .EQ. 'C ') THEN
	      at_mc (IATM)	= .TRUE.
	    ELSE IF (atyp (1:2) .EQ. 'O ') THEN
	      at_mc (IATM)	= .TRUE.
	    ELSE IF (atyp (1:2) .EQ. 'CA') THEN
	      at_mc (IATM)	= .TRUE.
	    ELSE
	      at_mc (IATM)	= .FALSE.
	    END IF

	    GOTO 220
300	    CLOSE ( UNIT = 1 )
	NAT = IATM

C Record residue indices that point to the AT arrays.

	ires = 1
	res_index (1,1) = 1
	res_last = at_residue (1)
	nres_last = at_nresidue (1)
	chain_last = at_chainid (1)
	DO 400 iatm	= 2, nat
	  IF ( (at_residue (iatm) .EQ. res_last) .AND.
     1	      (at_nresidue (iatm) .EQ. nres_last) .AND.
     2	      (at_chainid (iatm) .EQ. chain_last) ) GOTO 400
	  ires = ires + 1
	  res_index (ires,1) = iatm
	  res_index (ires-1,2) = iatm-1
	  res_last = at_residue (iatm)
	  nres_last = at_nresidue (iatm)
	  chain_last = at_chainid (iatm)
400	CONTINUE
	num_res = ires
	res_index (num_res,2) = nat

C We will box the atoms into grid cells of dimension 2(rmax+rprobe).
C This will speed the search for nearest neighbour atoms.
C Generate the box parameters from the extent of the atomic ordinates.

C The BOX array contains the starting index in the ATBOX array for atoms
C in this BOX (i,j,k..) slot, followed by the number of atoms in this
C slot.
C The ATBOX array contains the indices of atoms in the AT array, ordered

	STEP = 2. * ( RMAX + RPROBE )

	DO 470 N = 1, 3
	    XYZMIN (N) = XYZMIN (N) - 0.1
	    TMP = XYZMAX (N) - XYZMIN (N)
	    IJKM (N) = 2 + INT ( TMP / STEP )
	    IF ( IJKM (N) .GT. 35 ) STOP 'BOX IJK > 35'
470	CONTINUE

C Ok then, lets put these little ol atoms away.
C The first pass through the AT array fills BOX with the number of
C atoms in each box data, (BOX(i,j,k,2)).
C Using this data we will generate the BOX(i,j,k,1) slot, which
C contains the starting index in the ATBOX array for this i,j,k
C box.
C Then we can fill up the ATBOX array, with the BOX array, and a
C second pass through the AT array.

C Initialise the BOX array.

	DO 530 M = 1, 2
	    DO 530 K = 1, IJKM (3)
		DO 530 J = 1, IJKM (2)
		    DO 530 I = 1, IJKM (1)
			BOX ( I,J,K,M ) = 0
530		CONTINUE

	DO 550 IATM = 1, NAT

	    DO 510 N = 1, 3
		XYZ (N) = AT (IATM,N)
510	    CONTINUE

	    CALL BOXIJK ( XYZ, IJK )

	    BOX ( IJK(1), IJK(2), IJK(3), 2 ) =
     1      BOX ( IJK(1), IJK(2), IJK(3), 2 ) + 1

550	CONTINUE

C We will have k varying quickest in the BOX array.

	IATM = 0
	BOX ( 1,1,1,1 ) = 1

	DO 600 I = 1, IJKM (1)
	    DO 600 J = 1, IJKM (2)
		DO 600 K = 1, IJKM (3)

		    IATM = IATM + BOX ( I,J,K,2 )
		    IF ( I.EQ.1 .AND. J.EQ.1 .AND. K.EQ.1 ) GOTO 590
		    BOX ( I,J,K,1 ) = IATMOLD + 1

590		    IATMOLD = IATM
600	      CONTINUE

	IF ( IATM .NE. NAT ) STOP 'IATM<>NAT'

C Initialise the ATBOX array with zeroes, so that we know that any zero
C location has not 'yet' been used.

	DO 610 IATM = 1, NAT + 1
	    ATBOX ( IATM ) = 0
610	CONTINUE

	DO 700 IATM = 1, NAT

	    DO 620 N = 1, 3
		XYZ (N) = AT (IATM,N)
620	    CONTINUE

	    CALL BOXIJK ( XYZ, IJK )

	    I = IJK (1)
	    J = IJK (2)
	    K = IJK (3)

C Go through the section of ATBOX corresponding to this box ijk, and
C fill up the first zero location with the index to the AT array.

	    IF ( BOX ( I,J,K,2 ) .EQ. 0 ) STOP 'NONE HERE?'
	    LOC1 = BOX ( I,J,K,1 )
	    LOC2 = LOC1 + BOX ( I,J,K,2 ) - 1

	    DO 640 LOC = LOC1, LOC2
		IF ( ATBOX (LOC) .NE. 0 ) GOTO 640
		IF ( LOC .GT. NAT+1 ) STOP 'Have location over the top'
		ATBOX (LOC) = IATM
		GOTO 650
640	    CONTINUE
	    STOP 'No free location found'

650	    CONTINUE
700	CONTINUE						! End IATM

C We need to know how many planes we are dividing the 2*STEP distance,
C on the z-axis, up with.

	NPLN = 1 + 2 * ( 1 + INT ( STEP / PLNDIV ) )

C Now we can set about getting the per residue S.A. values.

	OPEN (UNIT=2,NAME='sa_calc.out',TYPE='NEW')
	IF (atoms_out) THEN
	  WRITE (2,1037)
	ELSE
	  WRITE (2,1035)
	END IF
	IF (atoms_out) THEN
	  WRITE (2,1055)
	ELSE IF (keep_mdl) THEN
	  WRITE (2,1040)
	ELSE
	  WRITE (2,1050)
	END IF

	tot		= 0.
	tot_p		= 0.
	tot_semip	= 0.
	tot_nonp	= 0.
	tot_mc		= 0.
	tot_sc		= 0.

	DO 860 ires = 1, num_res
	  tot_res 	= 0.
	  tot_res_p 	= 0.
	  tot_res_semip	= 0.
	  tot_res_nonp	= 0.
	  tot_res_mc	= 0.
	  tot_res_sc	= 0.
	  sc_nonpolar	= 0.
	  sc_polar	= 0.
	  DO 840 iat = res_index (ires,1), res_index (ires,2)

	    DO 760 N = 1, 3
		XYZC (N) = AT (iat,N)
760	    CONTINUE						! End N

	    XC = XYZC (1)
	    YC = XYZC (2)
	    ZC = XYZC (3)

	    CALL BOXIJK ( XYZC, IJKC )

	    RC = AT (iat,4) + RPROBE

C Now we take this and all neighbouring box cells for atoms that
C may overlap this charge location.

	    DO 780 N = 1, 3
		IJK1 (N) = IJKC (N) - 1
		IF ( IJK1 (N) .LT. 1 ) IJK1 (N) = 1
		IJK2 (N) = IJKC (N) + 1
		IF ( IJK2 (N) .GT. IJKM (N) ) IJK2 (N) = IJKM (N)
780	    CONTINUE						! End N

C The algorithm for the S.A. calcn. is that originated by Lee & Richards,
C and outlined in Matthew et al. BBRC 81, 410- (1978).

C The whole set of atoms is cut by planes (on z) and arcs of the central
C atom on these planes, that are not cut out by neighbouring atoms, are
C summed to give the S.A. value.

C Lets loop over those z-axis planes then.

	    ARC = 0.

	    DO 820 IPLN = 1, NPLN

C Initialise FREE to no overlap for the next plane through the central atom.

		DO 783 IANG = 1, NANG
		    FREE (IANG) = .TRUE.
783		CONTINUE					! End IANG

C @@@@@@ Check this plane division coverage out, please.

		ZPLN = XYZC (3) - STEP + FLOAT (IPLN-1) * PLNDIV

C Work out the radius of the central atom/probe sphere on this z-plane.

		RCZSQ = RC**2 - (ZC-ZPLN)**2
		IF ( RCZSQ .LE. 0. ) GOTO 820
		RCZ = SQRT ( RCZSQ )

		DO 800 I = IJK1 (1), IJK2 (1)
		    DO 800 J = IJK1 (2), IJK2 (2)
			DO 800 K = IJK1 (3), IJK2 (3)
			    IF ( BOX ( I,J,K,2 ) .EQ. 0 ) GOTO 800
			    LOC1 = BOX ( I,J,K,1 )
			    LOC2 = LOC1 + BOX ( I,J,K,2 )
			    DO 790 IPT = LOC1, LOC2
				IATM = ATBOX (IPT)
			    IF (IATM .EQ. iat) GOTO 790
				XAT = AT (IATM,1)
				YAT = AT (IATM,2)
				ZAT = AT (IATM,3)

C @@@@@ If we are very close to the central atom, then we are probably
C @@@@@ it, (charges in the AT array too).  Lets get out of here !

				DCAT = SQRT ( (XC-XAT)**2 +
     1				         (YC-YAT)**2 + (ZC-ZAT)**2 )
				IF ( DCAT .LT. 0.1 ) GOTO 790

				RAT = AT (IATM,4) + RPROBE

C Work out the radius of circle with which this atom/probe sphere cuts the
C z-plane.

				RATZSQ = RAT**2 - (ZPLN-ZAT)**2
				IF ( RATZSQ .LE. 0. ) GOTO 790
				RATZ = SQRT ( RATZSQ )

C Ok then; Is there any overlap between these two circles ?
C Work just in the x-y dimension now.

				DCATZ = SQRT ((XC-XAT)**2+(YC-YAT)**2)
				IF ( (RCZ+RATZ) .LT. DCATZ ) GOTO 790

C For each pair of circles within interesecting range, there are 3
C possibilities.  Two are with one circle inside the other.  The other
C is the more usual case for two point intersection of the circles.

C This tests for the central atom circle inside the neighbour atom
C circle; and if so there will be NO S.A. on this z-plane.

				IF ( (RCZ+DCATZ) .GT. RATZ ) GOTO 785
				IANG1 = 1
				IANG2 = NANG
				GOTO 788

C This tests for the neighbour atom circle inside the central atom
C circle; and if so there will be no occlusion by this neighbour.

785				IF ( (RATZ+DCATZ) .LE. RCZ ) GOTO 790

C We must be at the two point intersection case now.  Find the circular
C polar angles corresponding to the two intersection pts, seen from centre.

				COSALP=(RCZ*RCZ+DCATZ*DCATZ-RATZ*RATZ)
     1                                 / (2.*RCZ*DCATZ)
				IF (COSALP .GT. 1.0) COSALP = 1.0
				IF (COSALP .LT.-1.0) COSALP =-1.0
				ALP = ACOS ( COSALP )
				COSBET = (XAT-XC) / DCATZ
				BET = ACOS ( COSBET )
				IF ( (YAT-YC) .LT. 0. )
     1                             BET = TWOPI - BET
				THET1 = BET - ALP
				IF ( THET1 .GT. TWOPI )
     1                             THET1 = THET1 - TWOPI
				IF ( THET1 .LT. 0. )
     1                             THET1 = THET1 + TWOPI
				THET2 = THET1 + 2.*ALP
				IF ( THET2 .GT. TWOPI )
     1                             THET2 = THET2 - TWOPI
				IF ( THET2 .LT. 0. )
     1                             THET2 = THET2 + TWOPI

				IANG1 = 2 + INT ( (THET1/DANG) )
				IANG2 = 1 + INT ( (THET2/DANG) )
				IF ( IANG1 .GT. NANG ) IANG1 = NANG
				IF ( IANG2 .GT. NANG ) IANG2 = NANG

788				IF ( IANG1 .GT. IANG2 ) GOTO 7885

				DO 789 IANG = IANG1, IANG2
				    FREE (IANG) = .FALSE.
789				CONTINUE			! End IANG
				GOTO 790

7885				CONTINUE

				DO 7886 IANG = IANG1, NANG
				    FREE (IANG) = .FALSE.
7886				CONTINUE			! End IANG

				DO 7887 IANG = 1, IANG2
				    FREE (IANG) = .FALSE.
7887				CONTINUE			! End IANG

790			    CONTINUE				! End IPT

800		    CONTINUE					! End K,J,I

C The summation of the plane arc lengths is a JW thing, rather than a
C copy of the previous incumbents of the es - SA mantel.
C The plane contribution is not modified by any z fn, since the dec
C in RC is cancelled by the increase in modified delz as fn z.

		    NFREE = 0
		    DO 808 IANG = 1, NANG
			IF ( FREE (IANG) ) NFREE = NFREE + 1
808		    CONTINUE					! End IANG

		    ARCZ = TWOPI * ( FLOAT (NFREE) / FLOAT (NANG) )
		    ARC = ARC + ARCZ

820	    CONTINUE						! End IPLN

C Get the S.A. value in Angstrom squared.

	    AREA = RC * PLNDIV * ARC

C Get, and store, the fractional S.A. value.
C ??	    FSA = AREA / ( 4. * PI * RC**2 )
C ??	    IF ( FSA .GT. 1. ) STOP 'frac S.A. > 1.'
C ??	    IF ( FSA .LT. 0. ) STOP 'frac S.A. < 0.'
C ?? 100*FSA to get percentage

	    IF (atoms_out) THEN
	      IF (at_polar (iat)) THEN
	        atom_polar	= AREA
	        atom_nonpolar	= 0.
	      ELSE
	        atom_polar	= 0.
	        atom_nonpolar	= AREA
	      END IF
	      IF (at_mc (iat)) THEN
	        mc_sc_code	= 'MC'
	      ELSE
	        mc_sc_code	= 'SC'
		IF (at_atyp (iat) .NE. 'CB  ') THEN
		  sc_nonpolar	= sc_nonpolar + atom_nonpolar
		  sc_polar	= sc_polar + atom_polar
		END IF
	      END IF
	      iffy = res_index (ires,1)
	      WRITE (2,2020) at_chainid(iffy),at_nresidue(iffy),
     1			     at_residue(iffy),mc_sc_code,at_atyp(iat),
     2			     atom_polar, atom_nonpolar
	    END IF

	    tot_res		= tot_res + AREA
	    IF (at_polar (iat)) THEN
	      tot_res_p 	= tot_res_p + AREA
	    ELSE IF (at_semipolar (iat)) THEN
	      tot_res_semip 	= tot_res_semip + AREA
	    ELSE IF (at_nonpolar (iat)) THEN
	      tot_res_nonp	= tot_res_nonp + AREA
	    ELSE
	      STOP 'at not polr/semi/non'
	    END IF

	    IF (at_mc (iat)) THEN
	      tot_res_mc	= tot_res_mc + AREA
	    ELSE
	      tot_res_sc	= tot_res_sc + AREA
	    END IF
840	  CONTINUE
	if = res_index (ires,1)
	tot_res_np	= tot_res_semip + tot_res_nonp
	tot_res_np_prime = tot_res_nonp
	IF (keep_mdl) THEN
	 WRITE(2,1060) at_chainid(if),at_nresidue(if),at_residue(if),
     1		       tot_res,tot_res_p,tot_res_np,tot_res_np_prime,
     2		       tot_res_mc,tot_res_sc,at_model(if)
	ELSE
	 IF (atoms_out) THEN
	 WRITE(2,1075) at_chainid(if),at_nresidue(if),at_residue(if),
     1		       tot_res,sc_polar,sc_nonpolar
         END IF
	 WRITE(2,1070) at_chainid(if),at_nresidue(if),at_residue(if),
     1		       tot_res,tot_res_p,tot_res_np,tot_res_np_prime,
     2		       tot_res_mc,tot_res_sc
	END IF
	tot		= tot + tot_res
	tot_p		= tot_p + tot_res_p
	tot_semip	= tot_semip + tot_res_semip
	tot_nonp	= tot_nonp + tot_res_nonp
	tot_mc		= tot_mc + tot_res_mc
	tot_sc		= tot_sc + tot_res_sc
860	CONTINUE

	tot_np		= tot_semip + tot_nonp
	tot_np_prime	= tot_nonp
	WRITE (2,1080) tot,tot_p,tot_np,tot_np_prime,tot_mc,tot_sc,
     1		       RPROBE

	CLOSE (UNIT=2)

	RETURN
	END


	SUBROUTINE BOXIJK ( XYZ, IJK )
C	********** ******

C This routine simply returns the box cell index (IJK) for the
C ordinate set XYZ.

	REAL XYZ (3), XYZMIN (3), XYZMAX (3)
	INTEGER IJK (3), IJKM (3)

	COMMON /BOXGRD/ XYZMIN, XYZMAX, STEP, IJKM

	DO 120 N = 1, 3
	    DEL = XYZ (N) - XYZMIN (N)
	    IJK (N) = 1 + INT ( DEL / STEP )
	    TMP = DEL / STEP
	    IF ( ( TMP - FLOAT ( IJK(N)-1 ) ) .GT. 0.5 )
     1           IJK (N) = IJK (N) + 1
	    IF ( IJK (N) .LT. 1 ) STOP 'IJK (N) < 1'
	    IF ( IJK (N) .GT. IJKM (N) ) STOP 'IJK (N) > MAX'
120	CONTINUE

	RETURN
	END


	SUBROUTINE	leader (char_array, itop)
C	**********	******

	CHARACTER*60	char_array

	itop	= 1
	DO WHILE (char_array (itop:itop) .NE. ' ')
	  itop	= itop + 1
	END DO
	itop	= itop - 1

	RETURN
	END

